package com.nisum.offertransactionservice.controller;

import com.nisum.offertransactionservice.dto.EndOfSaleReq;
import com.nisum.offertransactionservice.dto.EndOfSaleResponse;
import com.nisum.offertransactionservice.dto.OfferTransactionRequest;
import com.nisum.offertransactionservice.dto.OfferTransactionResponse;
import com.nisum.offertransactionservice.service.EndOfSaleService;
import com.nisum.offertransactionservice.service.EndOfTransactionService;
import com.nisum.offertransactionservice.service.OfferCallingPEService;
import org.slf4j.MDC;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.io.IOException;

@RestController
@CrossOrigin("*")
public class OfferTransactionController {

    @Autowired
    private OfferCallingPEService offerCallingPEService;

    @Autowired
    private EndOfSaleService endOfSaleService;

    @Autowired
    private EndOfTransactionService endOfTransactionService;

    @PostMapping("offerTransactionCall")
    public OfferTransactionResponse getOfferTransactionResponse(@Valid @RequestBody OfferTransactionRequest offerTransactionRequest) throws InterruptedException {
        MDC.put("swy-res-unique-uuid", String.valueOf(offerTransactionRequest.getHhId()));
        MDC.put("user-id", String.valueOf(offerTransactionRequest.getHhId()));
        return offerCallingPEService.getDiscountedItemList(offerTransactionRequest);
    }


    @PostMapping("endOfSale")
    public EndOfSaleResponse endOfSale(@Valid @RequestBody EndOfSaleReq endOfSaleReq) throws IOException {
        MDC.put("swy-res-unique-uuid", endOfSaleReq.getOfferTransactionResponse().getHhid());
        MDC.put("user-id", endOfSaleReq.getOfferTransactionResponse().getHhid());
        String transactionID = endOfSaleService.putEndofSaleResInDb(endOfSaleReq);
        EndOfSaleResponse  endOfSaleResponse = new EndOfSaleResponse();
         endOfSaleResponse.setUuId(transactionID);
         return endOfSaleResponse;
    }


    @PostMapping("/endOfTransaction")
    public String endOfTransaction(@Valid @RequestBody String uuid) {
        MDC.put("swy-res-unique-uuid", uuid);
        MDC.put("user-id", uuid);
        return endOfTransactionService.endOfTransaction(uuid);

    }

}



