package com.nisum.offertransactionservice.service;

import com.nisum.offertransactionservice.client.ClientService;
import com.nisum.offertransactionservice.genericexception.GlobalApiGenericException;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.*;
import org.mockito.junit.MockitoJUnitRunner;

import org.springframework.test.web.reactive.server.WebTestClient;
import reactor.core.publisher.Mono;

@RunWith(MockitoJUnitRunner.class)
public class EndOfTransactionTest {

    @Mock
    private EndOfTransactionService endOfTransactionServiceMock;

    @InjectMocks
    @Spy
    private EndOfTransactionService endOfTransactionService = new EndOfTransactionService();

    @Mock
    ClientService clientService;;

    @Before
    public void setUp() throws Exception {
        MockitoAnnotations.initMocks(this);
    }


    @Test
    public void endOfTransactionTest() {
        String uuid = "86fd4146-0540-405b-b621-a95f4ccdfa0d";
        Mockito.when(clientService.getStringMono(ArgumentMatchers.any())).thenReturn(Mono.just("test"));
        Assert.assertNotNull(endOfTransactionService.endOfTransaction(uuid));
    }

    @Test(expected = GlobalApiGenericException.class)
    public void endOfTransactionNegTest() {
        String uuid = null;
        //Mockito.when(clientService.getStringMono(ArgumentMatchers.any())).thenReturn(Mono.just("test"));
       endOfTransactionService.endOfTransaction(uuid);
    }
}
